//
//  NSURLRequest+ZYJQNRequest.h
//  AppTest
//
//  Created by yangsen on 2020/4/8.
//  Copyright © 2020 com.qiniu. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface NSURLRequest(ZYJQNRequest)

/// 是否是七牛请求【内部使用】
/// 作为是否进行请求监听的判断依据 NO，当设置了ZYJQN_domain返回YES，反之为NO
@property(nonatomic, assign, readonly)BOOL ZYJQN_isQiNiuRequest;

/// 请求id【内部使用】
/// 只有通过设置ZYJQN_domain才会有效
@property(nonatomic, strong, nullable, readonly)NSString *ZYJQN_identifier;

/// 请求domain【内部使用】
/// 只有通过NSMutableURLRequest设置才会有效
@property(nonatomic, strong, nullable, readonly)NSString *ZYJQN_domain;

/// 请求头信息 去除七牛内部标记占位
@property(nonatomic, strong, nullable, readonly)NSDictionary *ZYJQN_allHTTPHeaderFields;

+ (instancetype)ZYJQN_requestWithURL:(NSURL *)url;

/// 获取请求体
- (NSData *)ZYJQN_getHttpBody;

- (BOOL)ZYJQN_isHttps;

@end


@interface NSMutableURLRequest(ZYJQNRequest)

/// 请求domain【内部使用】
@property(nonatomic, strong, nullable)NSString *ZYJQN_domain;

@end

NS_ASSUME_NONNULL_END
